Index: contrib/ntp/ntpd/ntp.conf.def
===================================================================
--- contrib/ntp/ntpd/ntp.conf.def	(版本 309693)
+++ contrib/ntp/ntpd/ntp.conf.def	(版本 310419)
@@ -1997,6 +1997,25 @@
 scheme starts all over from the beginning and
 the expanding ring shrinks to the minimum and increments
 from there while collecting all servers in scope.
+.Ss Broadcast Options
+.Bl -tag -width indent
+.It Xo Ic tos
+.Oo
+.Cm bcpollbstep Ar gate
+.Oc
+.Xc
+This command provides a way to delay,
+by the specified number of broadcast poll intervals,
+believing backward time steps from a broadcast server.
+Broadcast time networks are expected to be trusted.
+In the event a broadcast server's time is stepped backwards,
+there is clear benefit to having the clients notice this change
+as soon as possible.
+Attacks such as replay attacks can happen, however,
+and even though there are a number of protections built in to
+broadcast mode, attempts to perform  a replay attack are possible.
+This value defaults to 0, but can be changed
+to any number of poll intervals between 0 and 4.
 .Ss Manycast Options
 .Bl -tag -width indent
 .It Xo Ic tos
Index: contrib/ntp/ntpd/ntp.conf.mdoc.in
===================================================================
--- contrib/ntp/ntpd/ntp.conf.mdoc.in	(版本 309693)
+++ contrib/ntp/ntpd/ntp.conf.mdoc.in	(版本 310419)
@@ -1,9 +1,9 @@
-.Dd June 2 2016
+.Dd November 21 2016
 .Dt NTP_CONF 5 File Formats
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (ntp.mdoc)
 .\"
-.\"  It has been AutoGen-ed  June  2, 2016 at 07:36:16 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  November 21, 2016 at 08:02:03 AM by AutoGen 5.18.5
 .\"  From the definitions    ntp.conf.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
@@ -1995,6 +1995,25 @@
 scheme starts all over from the beginning and
 the expanding ring shrinks to the minimum and increments
 from there while collecting all servers in scope.
+.Ss Broadcast Options
+.Bl -tag -width indent
+.It Xo Ic tos
+.Oo
+.Cm bcpollbstep Ar gate
+.Oc
+.Xc
+This command provides a way to delay,
+by the specified number of broadcast poll intervals,
+believing backward time steps from a broadcast server.
+Broadcast time networks are expected to be trusted.
+In the event a broadcast server's time is stepped backwards,
+there is clear benefit to having the clients notice this change
+as soon as possible.
+Attacks such as replay attacks can happen, however,
+and even though there are a number of protections built in to
+broadcast mode, attempts to perform  a replay attack are possible.
+This value defaults to 0, but can be changed
+to any number of poll intervals between 0 and 4.
 .Ss Manycast Options
 .Bl -tag -width indent
 .It Xo Ic tos
Index: contrib/ntp/ntpd/ntp_config.c
===================================================================
--- contrib/ntp/ntpd/ntp_config.c	(版本 309693)
+++ contrib/ntp/ntpd/ntp_config.c	(版本 310419)
@@ -53,6 +53,12 @@
 #include "ntp_parser.h"
 #include "ntpd-opts.h"
 
+#ifndef IGNORE_DNS_ERRORS
+# define DNSFLAGS 0
+#else
+# define DNSFLAGS GAIR_F_IGNDNSERR
+#endif
+
 extern int yyparse(void);
 
 /* Bug 2817 */
@@ -2002,6 +2008,21 @@
 			INSIST(0);
 			break;
 
+		case T_Bcpollbstep:
+			if (val > 4) {
+				msyslog(LOG_WARNING,
+					"Using maximum bcpollbstep ceiling %d, %g requested",
+					4, val);
+				val = 4;
+			} else if (val < 0) {
+				msyslog(LOG_WARNING,
+					"Using minimum bcpollbstep floor %d, %g requested",
+					0, val);
+				val = 0;
+			}
+			item = PROTO_BCPOLLBSTEP;
+			break;
+
 		case T_Ceiling:
 			if (val > STRATUM_UNSPEC - 1) {
 				msyslog(LOG_WARNING,
@@ -3813,11 +3834,11 @@
 			hints.ai_socktype = SOCK_DGRAM;
 			hints.ai_protocol = IPPROTO_UDP;
 
-			getaddrinfo_sometime(*cmdline_servers,
+			getaddrinfo_sometime_ex(*cmdline_servers,
 					     "ntp", &hints,
 					     INITIAL_DNS_RETRY,
 					     &peer_name_resolved,
-					     (void *)ctx);
+					     (void *)ctx, DNSFLAGS);
 # else	/* !WORKER follows */
 			msyslog(LOG_ERR,
 				"hostname %s can not be used, please use IP address instead.",
@@ -3891,10 +3912,11 @@
 			hints.ai_socktype = SOCK_DGRAM;
 			hints.ai_protocol = IPPROTO_UDP;
 
-			getaddrinfo_sometime(curr_peer->addr->address,
+			getaddrinfo_sometime_ex(curr_peer->addr->address,
 					     "ntp", &hints,
 					     INITIAL_DNS_RETRY,
-					     &peer_name_resolved, ctx);
+					     &peer_name_resolved, ctx,
+					     DNSFLAGS);
 # else	/* !WORKER follows */
 			msyslog(LOG_ERR,
 				"hostname %s can not be used, please use IP address instead.",
@@ -3935,16 +3957,10 @@
 	DPRINTF(1, ("peer_name_resolved(%s) rescode %d\n", name, rescode));
 
 	if (rescode) {
-#ifndef IGNORE_DNS_ERRORS
 		free(ctx);
 		msyslog(LOG_ERR,
 			"giving up resolving host %s: %s (%d)",
 			name, gai_strerror(rescode), rescode);
-#else	/* IGNORE_DNS_ERRORS follows */
-		getaddrinfo_sometime(name, service, hints,
-				     INITIAL_DNS_RETRY,
-				     &peer_name_resolved, context);
-#endif
 		return;
 	}
 
Index: contrib/ntp/ntpd/ntp_parser.h
===================================================================
--- contrib/ntp/ntpd/ntp_parser.h	(版本 309693)
+++ contrib/ntp/ntpd/ntp_parser.h	(版本 310419)
@@ -55,191 +55,192 @@
     T_Automax = 265,
     T_Average = 266,
     T_Bclient = 267,
-    T_Beacon = 268,
-    T_Broadcast = 269,
-    T_Broadcastclient = 270,
-    T_Broadcastdelay = 271,
-    T_Burst = 272,
-    T_Calibrate = 273,
-    T_Ceiling = 274,
-    T_Clockstats = 275,
-    T_Cohort = 276,
-    T_ControlKey = 277,
-    T_Crypto = 278,
-    T_Cryptostats = 279,
-    T_Ctl = 280,
-    T_Day = 281,
-    T_Default = 282,
-    T_Digest = 283,
-    T_Disable = 284,
-    T_Discard = 285,
-    T_Dispersion = 286,
-    T_Double = 287,
-    T_Driftfile = 288,
-    T_Drop = 289,
-    T_Dscp = 290,
-    T_Ellipsis = 291,
-    T_Enable = 292,
-    T_End = 293,
-    T_False = 294,
-    T_File = 295,
-    T_Filegen = 296,
-    T_Filenum = 297,
-    T_Flag1 = 298,
-    T_Flag2 = 299,
-    T_Flag3 = 300,
-    T_Flag4 = 301,
-    T_Flake = 302,
-    T_Floor = 303,
-    T_Freq = 304,
-    T_Fudge = 305,
-    T_Host = 306,
-    T_Huffpuff = 307,
-    T_Iburst = 308,
-    T_Ident = 309,
-    T_Ignore = 310,
-    T_Incalloc = 311,
-    T_Incmem = 312,
-    T_Initalloc = 313,
-    T_Initmem = 314,
-    T_Includefile = 315,
-    T_Integer = 316,
-    T_Interface = 317,
-    T_Intrange = 318,
-    T_Io = 319,
-    T_Ipv4 = 320,
-    T_Ipv4_flag = 321,
-    T_Ipv6 = 322,
-    T_Ipv6_flag = 323,
-    T_Kernel = 324,
-    T_Key = 325,
-    T_Keys = 326,
-    T_Keysdir = 327,
-    T_Kod = 328,
-    T_Mssntp = 329,
-    T_Leapfile = 330,
-    T_Leapsmearinterval = 331,
-    T_Limited = 332,
-    T_Link = 333,
-    T_Listen = 334,
-    T_Logconfig = 335,
-    T_Logfile = 336,
-    T_Loopstats = 337,
-    T_Lowpriotrap = 338,
-    T_Manycastclient = 339,
-    T_Manycastserver = 340,
-    T_Mask = 341,
-    T_Maxage = 342,
-    T_Maxclock = 343,
-    T_Maxdepth = 344,
-    T_Maxdist = 345,
-    T_Maxmem = 346,
-    T_Maxpoll = 347,
-    T_Mdnstries = 348,
-    T_Mem = 349,
-    T_Memlock = 350,
-    T_Minclock = 351,
-    T_Mindepth = 352,
-    T_Mindist = 353,
-    T_Minimum = 354,
-    T_Minpoll = 355,
-    T_Minsane = 356,
-    T_Mode = 357,
-    T_Mode7 = 358,
-    T_Monitor = 359,
-    T_Month = 360,
-    T_Mru = 361,
-    T_Multicastclient = 362,
-    T_Nic = 363,
-    T_Nolink = 364,
-    T_Nomodify = 365,
-    T_Nomrulist = 366,
-    T_None = 367,
-    T_Nonvolatile = 368,
-    T_Nopeer = 369,
-    T_Noquery = 370,
-    T_Noselect = 371,
-    T_Noserve = 372,
-    T_Notrap = 373,
-    T_Notrust = 374,
-    T_Ntp = 375,
-    T_Ntpport = 376,
-    T_NtpSignDsocket = 377,
-    T_Orphan = 378,
-    T_Orphanwait = 379,
-    T_PCEdigest = 380,
-    T_Panic = 381,
-    T_Peer = 382,
-    T_Peerstats = 383,
-    T_Phone = 384,
-    T_Pid = 385,
-    T_Pidfile = 386,
-    T_Pool = 387,
-    T_Port = 388,
-    T_Preempt = 389,
-    T_Prefer = 390,
-    T_Protostats = 391,
-    T_Pw = 392,
-    T_Randfile = 393,
-    T_Rawstats = 394,
-    T_Refid = 395,
-    T_Requestkey = 396,
-    T_Reset = 397,
-    T_Restrict = 398,
-    T_Revoke = 399,
-    T_Rlimit = 400,
-    T_Saveconfigdir = 401,
-    T_Server = 402,
-    T_Setvar = 403,
-    T_Source = 404,
-    T_Stacksize = 405,
-    T_Statistics = 406,
-    T_Stats = 407,
-    T_Statsdir = 408,
-    T_Step = 409,
-    T_Stepback = 410,
-    T_Stepfwd = 411,
-    T_Stepout = 412,
-    T_Stratum = 413,
-    T_String = 414,
-    T_Sys = 415,
-    T_Sysstats = 416,
-    T_Tick = 417,
-    T_Time1 = 418,
-    T_Time2 = 419,
-    T_Timer = 420,
-    T_Timingstats = 421,
-    T_Tinker = 422,
-    T_Tos = 423,
-    T_Trap = 424,
-    T_True = 425,
-    T_Trustedkey = 426,
-    T_Ttl = 427,
-    T_Type = 428,
-    T_U_int = 429,
-    T_UEcrypto = 430,
-    T_UEcryptonak = 431,
-    T_UEdigest = 432,
-    T_Unconfig = 433,
-    T_Unpeer = 434,
-    T_Version = 435,
-    T_WanderThreshold = 436,
-    T_Week = 437,
-    T_Wildcard = 438,
-    T_Xleave = 439,
-    T_Year = 440,
-    T_Flag = 441,
-    T_EOC = 442,
-    T_Simulate = 443,
-    T_Beep_Delay = 444,
-    T_Sim_Duration = 445,
-    T_Server_Offset = 446,
-    T_Duration = 447,
-    T_Freq_Offset = 448,
-    T_Wander = 449,
-    T_Jitter = 450,
-    T_Prop_Delay = 451,
-    T_Proc_Delay = 452
+    T_Bcpollbstep = 268,
+    T_Beacon = 269,
+    T_Broadcast = 270,
+    T_Broadcastclient = 271,
+    T_Broadcastdelay = 272,
+    T_Burst = 273,
+    T_Calibrate = 274,
+    T_Ceiling = 275,
+    T_Clockstats = 276,
+    T_Cohort = 277,
+    T_ControlKey = 278,
+    T_Crypto = 279,
+    T_Cryptostats = 280,
+    T_Ctl = 281,
+    T_Day = 282,
+    T_Default = 283,
+    T_Digest = 284,
+    T_Disable = 285,
+    T_Discard = 286,
+    T_Dispersion = 287,
+    T_Double = 288,
+    T_Driftfile = 289,
+    T_Drop = 290,
+    T_Dscp = 291,
+    T_Ellipsis = 292,
+    T_Enable = 293,
+    T_End = 294,
+    T_False = 295,
+    T_File = 296,
+    T_Filegen = 297,
+    T_Filenum = 298,
+    T_Flag1 = 299,
+    T_Flag2 = 300,
+    T_Flag3 = 301,
+    T_Flag4 = 302,
+    T_Flake = 303,
+    T_Floor = 304,
+    T_Freq = 305,
+    T_Fudge = 306,
+    T_Host = 307,
+    T_Huffpuff = 308,
+    T_Iburst = 309,
+    T_Ident = 310,
+    T_Ignore = 311,
+    T_Incalloc = 312,
+    T_Incmem = 313,
+    T_Initalloc = 314,
+    T_Initmem = 315,
+    T_Includefile = 316,
+    T_Integer = 317,
+    T_Interface = 318,
+    T_Intrange = 319,
+    T_Io = 320,
+    T_Ipv4 = 321,
+    T_Ipv4_flag = 322,
+    T_Ipv6 = 323,
+    T_Ipv6_flag = 324,
+    T_Kernel = 325,
+    T_Key = 326,
+    T_Keys = 327,
+    T_Keysdir = 328,
+    T_Kod = 329,
+    T_Mssntp = 330,
+    T_Leapfile = 331,
+    T_Leapsmearinterval = 332,
+    T_Limited = 333,
+    T_Link = 334,
+    T_Listen = 335,
+    T_Logconfig = 336,
+    T_Logfile = 337,
+    T_Loopstats = 338,
+    T_Lowpriotrap = 339,
+    T_Manycastclient = 340,
+    T_Manycastserver = 341,
+    T_Mask = 342,
+    T_Maxage = 343,
+    T_Maxclock = 344,
+    T_Maxdepth = 345,
+    T_Maxdist = 346,
+    T_Maxmem = 347,
+    T_Maxpoll = 348,
+    T_Mdnstries = 349,
+    T_Mem = 350,
+    T_Memlock = 351,
+    T_Minclock = 352,
+    T_Mindepth = 353,
+    T_Mindist = 354,
+    T_Minimum = 355,
+    T_Minpoll = 356,
+    T_Minsane = 357,
+    T_Mode = 358,
+    T_Mode7 = 359,
+    T_Monitor = 360,
+    T_Month = 361,
+    T_Mru = 362,
+    T_Multicastclient = 363,
+    T_Nic = 364,
+    T_Nolink = 365,
+    T_Nomodify = 366,
+    T_Nomrulist = 367,
+    T_None = 368,
+    T_Nonvolatile = 369,
+    T_Nopeer = 370,
+    T_Noquery = 371,
+    T_Noselect = 372,
+    T_Noserve = 373,
+    T_Notrap = 374,
+    T_Notrust = 375,
+    T_Ntp = 376,
+    T_Ntpport = 377,
+    T_NtpSignDsocket = 378,
+    T_Orphan = 379,
+    T_Orphanwait = 380,
+    T_PCEdigest = 381,
+    T_Panic = 382,
+    T_Peer = 383,
+    T_Peerstats = 384,
+    T_Phone = 385,
+    T_Pid = 386,
+    T_Pidfile = 387,
+    T_Pool = 388,
+    T_Port = 389,
+    T_Preempt = 390,
+    T_Prefer = 391,
+    T_Protostats = 392,
+    T_Pw = 393,
+    T_Randfile = 394,
+    T_Rawstats = 395,
+    T_Refid = 396,
+    T_Requestkey = 397,
+    T_Reset = 398,
+    T_Restrict = 399,
+    T_Revoke = 400,
+    T_Rlimit = 401,
+    T_Saveconfigdir = 402,
+    T_Server = 403,
+    T_Setvar = 404,
+    T_Source = 405,
+    T_Stacksize = 406,
+    T_Statistics = 407,
+    T_Stats = 408,
+    T_Statsdir = 409,
+    T_Step = 410,
+    T_Stepback = 411,
+    T_Stepfwd = 412,
+    T_Stepout = 413,
+    T_Stratum = 414,
+    T_String = 415,
+    T_Sys = 416,
+    T_Sysstats = 417,
+    T_Tick = 418,
+    T_Time1 = 419,
+    T_Time2 = 420,
+    T_Timer = 421,
+    T_Timingstats = 422,
+    T_Tinker = 423,
+    T_Tos = 424,
+    T_Trap = 425,
+    T_True = 426,
+    T_Trustedkey = 427,
+    T_Ttl = 428,
+    T_Type = 429,
+    T_U_int = 430,
+    T_UEcrypto = 431,
+    T_UEcryptonak = 432,
+    T_UEdigest = 433,
+    T_Unconfig = 434,
+    T_Unpeer = 435,
+    T_Version = 436,
+    T_WanderThreshold = 437,
+    T_Week = 438,
+    T_Wildcard = 439,
+    T_Xleave = 440,
+    T_Year = 441,
+    T_Flag = 442,
+    T_EOC = 443,
+    T_Simulate = 444,
+    T_Beep_Delay = 445,
+    T_Sim_Duration = 446,
+    T_Server_Offset = 447,
+    T_Duration = 448,
+    T_Freq_Offset = 449,
+    T_Wander = 450,
+    T_Jitter = 451,
+    T_Prop_Delay = 452,
+    T_Proc_Delay = 453
   };
 #endif
 /* Tokens.  */
@@ -253,191 +254,192 @@
 #define T_Automax 265
 #define T_Average 266
 #define T_Bclient 267
-#define T_Beacon 268
-#define T_Broadcast 269
-#define T_Broadcastclient 270
-#define T_Broadcastdelay 271
-#define T_Burst 272
-#define T_Calibrate 273
-#define T_Ceiling 274
-#define T_Clockstats 275
-#define T_Cohort 276
-#define T_ControlKey 277
-#define T_Crypto 278
-#define T_Cryptostats 279
-#define T_Ctl 280
-#define T_Day 281
-#define T_Default 282
-#define T_Digest 283
-#define T_Disable 284
-#define T_Discard 285
-#define T_Dispersion 286
-#define T_Double 287
-#define T_Driftfile 288
-#define T_Drop 289
-#define T_Dscp 290
-#define T_Ellipsis 291
-#define T_Enable 292
-#define T_End 293
-#define T_False 294
-#define T_File 295
-#define T_Filegen 296
-#define T_Filenum 297
-#define T_Flag1 298
-#define T_Flag2 299
-#define T_Flag3 300
-#define T_Flag4 301
-#define T_Flake 302
-#define T_Floor 303
-#define T_Freq 304
-#define T_Fudge 305
-#define T_Host 306
-#define T_Huffpuff 307
-#define T_Iburst 308
-#define T_Ident 309
-#define T_Ignore 310
-#define T_Incalloc 311
-#define T_Incmem 312
-#define T_Initalloc 313
-#define T_Initmem 314
-#define T_Includefile 315
-#define T_Integer 316
-#define T_Interface 317
-#define T_Intrange 318
-#define T_Io 319
-#define T_Ipv4 320
-#define T_Ipv4_flag 321
-#define T_Ipv6 322
-#define T_Ipv6_flag 323
-#define T_Kernel 324
-#define T_Key 325
-#define T_Keys 326
-#define T_Keysdir 327
-#define T_Kod 328
-#define T_Mssntp 329
-#define T_Leapfile 330
-#define T_Leapsmearinterval 331
-#define T_Limited 332
-#define T_Link 333
-#define T_Listen 334
-#define T_Logconfig 335
-#define T_Logfile 336
-#define T_Loopstats 337
-#define T_Lowpriotrap 338
-#define T_Manycastclient 339
-#define T_Manycastserver 340
-#define T_Mask 341
-#define T_Maxage 342
-#define T_Maxclock 343
-#define T_Maxdepth 344
-#define T_Maxdist 345
-#define T_Maxmem 346
-#define T_Maxpoll 347
-#define T_Mdnstries 348
-#define T_Mem 349
-#define T_Memlock 350
-#define T_Minclock 351
-#define T_Mindepth 352
-#define T_Mindist 353
-#define T_Minimum 354
-#define T_Minpoll 355
-#define T_Minsane 356
-#define T_Mode 357
-#define T_Mode7 358
-#define T_Monitor 359
-#define T_Month 360
-#define T_Mru 361
-#define T_Multicastclient 362
-#define T_Nic 363
-#define T_Nolink 364
-#define T_Nomodify 365
-#define T_Nomrulist 366
-#define T_None 367
-#define T_Nonvolatile 368
-#define T_Nopeer 369
-#define T_Noquery 370
-#define T_Noselect 371
-#define T_Noserve 372
-#define T_Notrap 373
-#define T_Notrust 374
-#define T_Ntp 375
-#define T_Ntpport 376
-#define T_NtpSignDsocket 377
-#define T_Orphan 378
-#define T_Orphanwait 379
-#define T_PCEdigest 380
-#define T_Panic 381
-#define T_Peer 382
-#define T_Peerstats 383
-#define T_Phone 384
-#define T_Pid 385
-#define T_Pidfile 386
-#define T_Pool 387
-#define T_Port 388
-#define T_Preempt 389
-#define T_Prefer 390
-#define T_Protostats 391
-#define T_Pw 392
-#define T_Randfile 393
-#define T_Rawstats 394
-#define T_Refid 395
-#define T_Requestkey 396
-#define T_Reset 397
-#define T_Restrict 398
-#define T_Revoke 399
-#define T_Rlimit 400
-#define T_Saveconfigdir 401
-#define T_Server 402
-#define T_Setvar 403
-#define T_Source 404
-#define T_Stacksize 405
-#define T_Statistics 406
-#define T_Stats 407
-#define T_Statsdir 408
-#define T_Step 409
-#define T_Stepback 410
-#define T_Stepfwd 411
-#define T_Stepout 412
-#define T_Stratum 413
-#define T_String 414
-#define T_Sys 415
-#define T_Sysstats 416
-#define T_Tick 417
-#define T_Time1 418
-#define T_Time2 419
-#define T_Timer 420
-#define T_Timingstats 421
-#define T_Tinker 422
-#define T_Tos 423
-#define T_Trap 424
-#define T_True 425
-#define T_Trustedkey 426
-#define T_Ttl 427
-#define T_Type 428
-#define T_U_int 429
-#define T_UEcrypto 430
-#define T_UEcryptonak 431
-#define T_UEdigest 432
-#define T_Unconfig 433
-#define T_Unpeer 434
-#define T_Version 435
-#define T_WanderThreshold 436
-#define T_Week 437
-#define T_Wildcard 438
-#define T_Xleave 439
-#define T_Year 440
-#define T_Flag 441
-#define T_EOC 442
-#define T_Simulate 443
-#define T_Beep_Delay 444
-#define T_Sim_Duration 445
-#define T_Server_Offset 446
-#define T_Duration 447
-#define T_Freq_Offset 448
-#define T_Wander 449
-#define T_Jitter 450
-#define T_Prop_Delay 451
-#define T_Proc_Delay 452
+#define T_Bcpollbstep 268
+#define T_Beacon 269
+#define T_Broadcast 270
+#define T_Broadcastclient 271
+#define T_Broadcastdelay 272
+#define T_Burst 273
+#define T_Calibrate 274
+#define T_Ceiling 275
+#define T_Clockstats 276
+#define T_Cohort 277
+#define T_ControlKey 278
+#define T_Crypto 279
+#define T_Cryptostats 280
+#define T_Ctl 281
+#define T_Day 282
+#define T_Default 283
+#define T_Digest 284
+#define T_Disable 285
+#define T_Discard 286
+#define T_Dispersion 287
+#define T_Double 288
+#define T_Driftfile 289
+#define T_Drop 290
+#define T_Dscp 291
+#define T_Ellipsis 292
+#define T_Enable 293
+#define T_End 294
+#define T_False 295
+#define T_File 296
+#define T_Filegen 297
+#define T_Filenum 298
+#define T_Flag1 299
+#define T_Flag2 300
+#define T_Flag3 301
+#define T_Flag4 302
+#define T_Flake 303
+#define T_Floor 304
+#define T_Freq 305
+#define T_Fudge 306
+#define T_Host 307
+#define T_Huffpuff 308
+#define T_Iburst 309
+#define T_Ident 310
+#define T_Ignore 311
+#define T_Incalloc 312
+#define T_Incmem 313
+#define T_Initalloc 314
+#define T_Initmem 315
+#define T_Includefile 316
+#define T_Integer 317
+#define T_Interface 318
+#define T_Intrange 319
+#define T_Io 320
+#define T_Ipv4 321
+#define T_Ipv4_flag 322
+#define T_Ipv6 323
+#define T_Ipv6_flag 324
+#define T_Kernel 325
+#define T_Key 326
+#define T_Keys 327
+#define T_Keysdir 328
+#define T_Kod 329
+#define T_Mssntp 330
+#define T_Leapfile 331
+#define T_Leapsmearinterval 332
+#define T_Limited 333
+#define T_Link 334
+#define T_Listen 335
+#define T_Logconfig 336
+#define T_Logfile 337
+#define T_Loopstats 338
+#define T_Lowpriotrap 339
+#define T_Manycastclient 340
+#define T_Manycastserver 341
+#define T_Mask 342
+#define T_Maxage 343
+#define T_Maxclock 344
+#define T_Maxdepth 345
+#define T_Maxdist 346
+#define T_Maxmem 347
+#define T_Maxpoll 348
+#define T_Mdnstries 349
+#define T_Mem 350
+#define T_Memlock 351
+#define T_Minclock 352
+#define T_Mindepth 353
+#define T_Mindist 354
+#define T_Minimum 355
+#define T_Minpoll 356
+#define T_Minsane 357
+#define T_Mode 358
+#define T_Mode7 359
+#define T_Monitor 360
+#define T_Month 361
+#define T_Mru 362
+#define T_Multicastclient 363
+#define T_Nic 364
+#define T_Nolink 365
+#define T_Nomodify 366
+#define T_Nomrulist 367
+#define T_None 368
+#define T_Nonvolatile 369
+#define T_Nopeer 370
+#define T_Noquery 371
+#define T_Noselect 372
+#define T_Noserve 373
+#define T_Notrap 374
+#define T_Notrust 375
+#define T_Ntp 376
+#define T_Ntpport 377
+#define T_NtpSignDsocket 378
+#define T_Orphan 379
+#define T_Orphanwait 380
+#define T_PCEdigest 381
+#define T_Panic 382
+#define T_Peer 383
+#define T_Peerstats 384
+#define T_Phone 385
+#define T_Pid 386
+#define T_Pidfile 387
+#define T_Pool 388
+#define T_Port 389
+#define T_Preempt 390
+#define T_Prefer 391
+#define T_Protostats 392
+#define T_Pw 393
+#define T_Randfile 394
+#define T_Rawstats 395
+#define T_Refid 396
+#define T_Requestkey 397
+#define T_Reset 398
+#define T_Restrict 399
+#define T_Revoke 400
+#define T_Rlimit 401
+#define T_Saveconfigdir 402
+#define T_Server 403
+#define T_Setvar 404
+#define T_Source 405
+#define T_Stacksize 406
+#define T_Statistics 407
+#define T_Stats 408
+#define T_Statsdir 409
+#define T_Step 410
+#define T_Stepback 411
+#define T_Stepfwd 412
+#define T_Stepout 413
+#define T_Stratum 414
+#define T_String 415
+#define T_Sys 416
+#define T_Sysstats 417
+#define T_Tick 418
+#define T_Time1 419
+#define T_Time2 420
+#define T_Timer 421
+#define T_Timingstats 422
+#define T_Tinker 423
+#define T_Tos 424
+#define T_Trap 425
+#define T_True 426
+#define T_Trustedkey 427
+#define T_Ttl 428
+#define T_Type 429
+#define T_U_int 430
+#define T_UEcrypto 431
+#define T_UEcryptonak 432
+#define T_UEdigest 433
+#define T_Unconfig 434
+#define T_Unpeer 435
+#define T_Version 436
+#define T_WanderThreshold 437
+#define T_Week 438
+#define T_Wildcard 439
+#define T_Xleave 440
+#define T_Year 441
+#define T_Flag 442
+#define T_EOC 443
+#define T_Simulate 444
+#define T_Beep_Delay 445
+#define T_Sim_Duration 446
+#define T_Server_Offset 447
+#define T_Duration 448
+#define T_Freq_Offset 449
+#define T_Wander 450
+#define T_Jitter 451
+#define T_Prop_Delay 452
+#define T_Proc_Delay 453
 
 /* Value type.  */
 #if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
@@ -463,7 +465,7 @@
 	script_info *		Sim_script;
 	script_info_fifo *	Sim_script_fifo;
 
-#line 467 "../../ntpd/ntp_parser.h" /* yacc.c:1909  */
+#line 469 "ntp_parser.h" /* yacc.c:1909  */
 };
 
 typedef union YYSTYPE YYSTYPE;
Index: contrib/ntp/ntpd/ntp_refclock.c
===================================================================
--- contrib/ntp/ntpd/ntp_refclock.c	(版本 309693)
+++ contrib/ntp/ntpd/ntp_refclock.c	(版本 310419)
@@ -710,7 +710,7 @@
 	if (rio->io_input == NULL || (*rio->io_input)(rb) != 0) {
 		rio->recvcount++;
 		packets_received++;
-		handler_pkts++;		
+		handler_pkts++;
 		(*rio->clock_recv)(rb);
 	}
 }
@@ -1208,6 +1208,7 @@
 			    "refclock_ppsapi: time_pps_create: %m");
 			return (0);
 		}
+		ZERO(ap->ts); /* [Bug 2689] defined INIT state */
 	}
 	return (1);
 }
@@ -1278,7 +1279,7 @@
 	struct refclockproc *pp;
 	pps_info_t pps_info;
 	struct timespec timeout;
-	double	dtemp;
+	double	dtemp, dcorr, trash;
 
 	/*
 	 * We require the clock to be synchronized before setting the
@@ -1293,8 +1294,7 @@
 		if (refclock_params(pp->sloppyclockflag, ap) < 1)
 			return (0);
 	}
-	timeout.tv_sec = 0;
-	timeout.tv_nsec = 0;
+	ZERO(timeout);
 	ZERO(pps_info);
 	if (time_pps_fetch(ap->handle, PPS_TSFMT_TSPEC, &pps_info,
 	    &timeout) < 0) {
@@ -1301,7 +1301,7 @@
 		refclock_report(peer, CEVNT_FAULT);
 		return (0);
 	}
-	timeout = ap->ts;
+	timeout = ap->ts;	/* save old timestamp for check */
 	if (ap->pps_params.mode & PPS_CAPTUREASSERT)
 		ap->ts = pps_info.assert_timestamp;
 	else if (ap->pps_params.mode & PPS_CAPTURECLEAR)
@@ -1309,22 +1309,62 @@
 	else
 		return (0);
 
+	/* [Bug 2689] Discard the first sample we read -- if the PPS
+	 * source is currently down / disconnected, we have read a
+	 * potentially *very* stale value here. So if our old TS value
+	 * is all-zero, we consider this sample unrealiable and drop it.
+	 *
+	 * Note 1: a better check would compare the PPS time stamp to
+	 * the current system time and drop it if it's more than say 3s
+	 * away.
+	 *
+	 * Note 2: If we ever again get an all-zero PPS sample, the next
+	 * one will be discarded. This can happen every 136yrs and is
+	 * unlikely to be ever observed.
+	 */
+	if (0 == (timeout.tv_sec | timeout.tv_nsec))
+		return (0);
+
+	/* If the PPS source fails to deliver a new sample between
+	 * polls, it regurgitates the last sample. We do not want to
+	 * process the same sample multiple times.
+	 */
 	if (0 == memcmp(&timeout, &ap->ts, sizeof(timeout)))
 		return (0);
 
 	/*
-	 * Convert to signed fraction offset and stuff in median filter.
+	 * Convert to signed fraction offset, apply fudge and properly
+	 * fold the correction into the [-0.5s,0.5s] range. Handle
+	 * excessive fudge times, too.
 	 */
+	dtemp = ap->ts.tv_nsec / 1e9;
+	dcorr = modf((pp->fudgetime1 - dtemp), &trash);
+	if (dcorr > 0.5)
+		dcorr -= 1.0;
+	else if (dcorr < -0.5)
+		dcorr += 1.0;
+
+	/* phase gate check: avoid wobbling by +/-1s when too close to
+	 * the switch-over point. We allow +/-400ms max phase deviation.
+	 * The trade-off is clear: The smaller the limit, the less
+	 * sensitive to sampling noise the clock becomes. OTOH the
+	 * system must get into phase gate range by other means for the
+	 * PPS clock to lock in.
+	 */
+	if (fabs(dcorr) > 0.4)
+		return (0);
+
+	/*
+	 * record this time stamp and stuff in median filter
+	 */
 	pp->lastrec.l_ui = (u_int32)ap->ts.tv_sec + JAN_1970;
-	dtemp = ap->ts.tv_nsec / 1e9;
 	pp->lastrec.l_uf = (u_int32)(dtemp * FRAC);
-	if (dtemp > .5)
-		dtemp -= 1.;
-	SAMPLE(-dtemp + pp->fudgetime1);
+	SAMPLE(dcorr);
+	
 #ifdef DEBUG
 	if (debug > 1)
 		printf("refclock_pps: %lu %f %f\n", current_time,
-		    dtemp, pp->fudgetime1);
+		    dcorr, pp->fudgetime1);
 #endif
 	return (1);
 }
Index: contrib/ntp/ntpd/ntpd.1ntpdmdoc
===================================================================
--- contrib/ntp/ntpd/ntpd.1ntpdmdoc	(版本 309693)
+++ contrib/ntp/ntpd/ntpd.1ntpdmdoc	(版本 310419)
@@ -1,9 +1,9 @@
-.Dd June 2 2016
+.Dd November 21 2016
 .Dt NTPD 1ntpdmdoc User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (ntpd-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  June  2, 2016 at 07:36:22 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  November 21, 2016 at 08:02:08 AM by AutoGen 5.18.5
 .\"  From the definitions    ntpd-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
Index: contrib/ntp/ntpd/ntpd.1ntpdman
===================================================================
--- contrib/ntp/ntpd/ntpd.1ntpdman	(版本 309693)
+++ contrib/ntp/ntpd/ntpd.1ntpdman	(版本 310419)
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH ntpd 1ntpdman "02 Jun 2016" "4.2.8p8" "User Commands"
+.TH ntpd 1ntpdman "21 Nov 2016" "4.2.8p9" "User Commands"
 .\"
-.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-Jnai2U/ag-Ynaa1U)
+.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-giaGkh/ag-tiayjh)
 .\"
-.\" It has been AutoGen-ed June 2, 2016 at 07:36:01 AM by AutoGen 5.18.5
+.\" It has been AutoGen-ed November 21, 2016 at 08:01:50 AM by AutoGen 5.18.5
 .\" From the definitions ntpd-opts.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
Index: contrib/ntp/ntpd/ntpd.mdoc.in
===================================================================
--- contrib/ntp/ntpd/ntpd.mdoc.in	(版本 309693)
+++ contrib/ntp/ntpd/ntpd.mdoc.in	(版本 310419)
@@ -1,9 +1,9 @@
-.Dd June 2 2016
+.Dd November 21 2016
 .Dt NTPD @NTPD_MS@ User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (ntpd-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  June  2, 2016 at 07:36:22 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  November 21, 2016 at 08:02:08 AM by AutoGen 5.18.5
 .\"  From the definitions    ntpd-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
Index: contrib/ntp/ntpdc/ntpdc.1ntpdcmdoc
===================================================================
--- contrib/ntp/ntpdc/ntpdc.1ntpdcmdoc	(版本 309693)
+++ contrib/ntp/ntpdc/ntpdc.1ntpdcmdoc	(版本 310419)
@@ -1,9 +1,9 @@
-.Dd June 2 2016
+.Dd November 21 2016
 .Dt NTPDC 1ntpdcmdoc User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (ntpdc-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  June  2, 2016 at 07:36:58 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  November 21, 2016 at 08:02:35 AM by AutoGen 5.18.5
 .\"  From the definitions    ntpdc-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
Index: contrib/ntp/ntpq/ntpq.1ntpqmdoc
===================================================================
--- contrib/ntp/ntpq/ntpq.1ntpqmdoc	(版本 309693)
+++ contrib/ntp/ntpq/ntpq.1ntpqmdoc	(版本 310419)
@@ -1,9 +1,9 @@
-.Dd June 2 2016
+.Dd November 21 2016
 .Dt NTPQ 1ntpqmdoc User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (ntpq-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  June  2, 2016 at 07:37:48 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  November 21, 2016 at 08:03:08 AM by AutoGen 5.18.5
 .\"  From the definitions    ntpq-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
Index: contrib/ntp/ntpq/ntpq.mdoc.in
===================================================================
--- contrib/ntp/ntpq/ntpq.mdoc.in	(版本 309693)
+++ contrib/ntp/ntpq/ntpq.mdoc.in	(版本 310419)
@@ -1,9 +1,9 @@
-.Dd June 2 2016
+.Dd November 21 2016
 .Dt NTPQ @NTPQ_MS@ User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (ntpq-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  June  2, 2016 at 07:37:48 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  November 21, 2016 at 08:03:08 AM by AutoGen 5.18.5
 .\"  From the definitions    ntpq-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
Index: contrib/ntp/ntpd/ntpd-opts.h
===================================================================
--- contrib/ntp/ntpd/ntpd-opts.h	(版本 309693)
+++ contrib/ntp/ntpd/ntpd-opts.h	(版本 310419)
@@ -1,7 +1,7 @@
 /*
  *  EDIT THIS FILE WITH CAUTION  (ntpd-opts.h)
  *
- *  It has been AutoGen-ed  June  2, 2016 at 07:32:40 AM by AutoGen 5.18.5
+ *  It has been AutoGen-ed  November 21, 2016 at 07:59:42 AM by AutoGen 5.18.5
  *  From the definitions    ntpd-opts.def
  *  and the template file   options
  *
@@ -106,9 +106,9 @@
 /** count of all options for ntpd */
 #define OPTION_CT    38
 /** ntpd version */
-#define NTPD_VERSION       "4.2.8p8"
+#define NTPD_VERSION       "4.2.8p9"
 /** Full ntpd version text */
-#define NTPD_FULL_VERSION  "ntpd 4.2.8p8"
+#define NTPD_FULL_VERSION  "ntpd 4.2.8p9"
 
 /**
  *  Interface defines for all options.  Replace "n" with the UPPER_CASED
Index: contrib/ntp/ntpd/ntpd.man.in
===================================================================
--- contrib/ntp/ntpd/ntpd.man.in	(版本 309693)
+++ contrib/ntp/ntpd/ntpd.man.in	(版本 310419)
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH ntpd @NTPD_MS@ "02 Jun 2016" "4.2.8p8" "User Commands"
+.TH ntpd @NTPD_MS@ "21 Nov 2016" "4.2.8p9" "User Commands"
 .\"
-.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-Jnai2U/ag-Ynaa1U)
+.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-giaGkh/ag-tiayjh)
 .\"
-.\" It has been AutoGen-ed June 2, 2016 at 07:36:01 AM by AutoGen 5.18.5
+.\" It has been AutoGen-ed November 21, 2016 at 08:01:50 AM by AutoGen 5.18.5
 .\" From the definitions ntpd-opts.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
